"""autogenerated by genpy from ethercat_monitor/EtherCATDeviceStatus.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import ethercat_monitor.msg

class EtherCATDeviceStatus(genpy.Message):
  _md5sum = "0f000b0496822a114b4a403658d6f5da"
  _type = "ethercat_monitor/EtherCATDeviceStatus"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# represents the data for a single EtherCAT device
string name
string hardware_id
int32  ring_position
int32  epu_errors
int32  pdi_errors
bool   valid 
EtherCATDevicePortStatus[] ports  # EtherCAT devices have 1-4 ports
================================================================================
MSG: ethercat_monitor/EtherCATDevicePortStatus
# Represents diagnostic information for a signle port of an EtherCAT device
int32 rx_errors
int32 forwarded_rx_errors
int32 frame_errors
int32 lost_links
bool open

# estimate of dropped packets that where cause by this port
# calculated by correlating occurence of frame_errors with drops from ethercat master data
int32 est_drops  


"""
  __slots__ = ['name','hardware_id','ring_position','epu_errors','pdi_errors','valid','ports']
  _slot_types = ['string','string','int32','int32','int32','bool','ethercat_monitor/EtherCATDevicePortStatus[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       name,hardware_id,ring_position,epu_errors,pdi_errors,valid,ports

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(EtherCATDeviceStatus, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.name is None:
        self.name = ''
      if self.hardware_id is None:
        self.hardware_id = ''
      if self.ring_position is None:
        self.ring_position = 0
      if self.epu_errors is None:
        self.epu_errors = 0
      if self.pdi_errors is None:
        self.pdi_errors = 0
      if self.valid is None:
        self.valid = False
      if self.ports is None:
        self.ports = []
    else:
      self.name = ''
      self.hardware_id = ''
      self.ring_position = 0
      self.epu_errors = 0
      self.pdi_errors = 0
      self.valid = False
      self.ports = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.hardware_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3iB.pack(_x.ring_position, _x.epu_errors, _x.pdi_errors, _x.valid))
      length = len(self.ports)
      buff.write(_struct_I.pack(length))
      for val1 in self.ports:
        _x = val1
        buff.write(_struct_4iBi.pack(_x.rx_errors, _x.forwarded_rx_errors, _x.frame_errors, _x.lost_links, _x.open, _x.est_drops))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(_x))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(_x))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.ports is None:
        self.ports = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8')
      else:
        self.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.hardware_id = str[start:end].decode('utf-8')
      else:
        self.hardware_id = str[start:end]
      _x = self
      start = end
      end += 13
      (_x.ring_position, _x.epu_errors, _x.pdi_errors, _x.valid,) = _struct_3iB.unpack(str[start:end])
      self.valid = bool(self.valid)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.ports = []
      for i in range(0, length):
        val1 = ethercat_monitor.msg.EtherCATDevicePortStatus()
        _x = val1
        start = end
        end += 21
        (_x.rx_errors, _x.forwarded_rx_errors, _x.frame_errors, _x.lost_links, _x.open, _x.est_drops,) = _struct_4iBi.unpack(str[start:end])
        val1.open = bool(val1.open)
        self.ports.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.hardware_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3iB.pack(_x.ring_position, _x.epu_errors, _x.pdi_errors, _x.valid))
      length = len(self.ports)
      buff.write(_struct_I.pack(length))
      for val1 in self.ports:
        _x = val1
        buff.write(_struct_4iBi.pack(_x.rx_errors, _x.forwarded_rx_errors, _x.frame_errors, _x.lost_links, _x.open, _x.est_drops))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(_x))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(_x))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.ports is None:
        self.ports = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8')
      else:
        self.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.hardware_id = str[start:end].decode('utf-8')
      else:
        self.hardware_id = str[start:end]
      _x = self
      start = end
      end += 13
      (_x.ring_position, _x.epu_errors, _x.pdi_errors, _x.valid,) = _struct_3iB.unpack(str[start:end])
      self.valid = bool(self.valid)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.ports = []
      for i in range(0, length):
        val1 = ethercat_monitor.msg.EtherCATDevicePortStatus()
        _x = val1
        start = end
        end += 21
        (_x.rx_errors, _x.forwarded_rx_errors, _x.frame_errors, _x.lost_links, _x.open, _x.est_drops,) = _struct_4iBi.unpack(str[start:end])
        val1.open = bool(val1.open)
        self.ports.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_3iB = struct.Struct("<3iB")
_struct_4iBi = struct.Struct("<4iBi")
