"""autogenerated by genpy from ethercat_monitor/SavedBagHeader.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy

class SavedBagHeader(genpy.Message):
  _md5sum = "acbb3d721f4ae2a620ddb08babfdb74f"
  _type = "ethercat_monitor/SavedBagHeader"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Header message containing information about saved bag file
time   save_time     # wall time when bag was saved
string topic_name    # name of ROS topic (probabbly /diagnostics) that data was recorded from
string machine_name  # name of machine that bag was saved from 
string user_name     # name of current user when bag was saved
int32  major_version # major version (should be 1)
int32  minor_version # minor version 
string yaml_data     # Extra data encoded in yaml format.  
                     # When format of yaml_data changes in backwards compatible manor, minor version should increase.
                     # When format of yaml_data changes in non-compatible way, major version should increase   
"""
  __slots__ = ['save_time','topic_name','machine_name','user_name','major_version','minor_version','yaml_data']
  _slot_types = ['time','string','string','string','int32','int32','string']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       save_time,topic_name,machine_name,user_name,major_version,minor_version,yaml_data

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SavedBagHeader, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.save_time is None:
        self.save_time = genpy.Time()
      if self.topic_name is None:
        self.topic_name = ''
      if self.machine_name is None:
        self.machine_name = ''
      if self.user_name is None:
        self.user_name = ''
      if self.major_version is None:
        self.major_version = 0
      if self.minor_version is None:
        self.minor_version = 0
      if self.yaml_data is None:
        self.yaml_data = ''
    else:
      self.save_time = genpy.Time()
      self.topic_name = ''
      self.machine_name = ''
      self.user_name = ''
      self.major_version = 0
      self.minor_version = 0
      self.yaml_data = ''

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_2I.pack(_x.save_time.secs, _x.save_time.nsecs))
      _x = self.topic_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.machine_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.user_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2i.pack(_x.major_version, _x.minor_version))
      _x = self.yaml_data
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(_x))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(_x))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.save_time is None:
        self.save_time = genpy.Time()
      end = 0
      _x = self
      start = end
      end += 8
      (_x.save_time.secs, _x.save_time.nsecs,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.topic_name = str[start:end].decode('utf-8')
      else:
        self.topic_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.machine_name = str[start:end].decode('utf-8')
      else:
        self.machine_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.user_name = str[start:end].decode('utf-8')
      else:
        self.user_name = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.major_version, _x.minor_version,) = _struct_2i.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.yaml_data = str[start:end].decode('utf-8')
      else:
        self.yaml_data = str[start:end]
      self.save_time.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_2I.pack(_x.save_time.secs, _x.save_time.nsecs))
      _x = self.topic_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.machine_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.user_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2i.pack(_x.major_version, _x.minor_version))
      _x = self.yaml_data
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(_x))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(_x))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.save_time is None:
        self.save_time = genpy.Time()
      end = 0
      _x = self
      start = end
      end += 8
      (_x.save_time.secs, _x.save_time.nsecs,) = _struct_2I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.topic_name = str[start:end].decode('utf-8')
      else:
        self.topic_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.machine_name = str[start:end].decode('utf-8')
      else:
        self.machine_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.user_name = str[start:end].decode('utf-8')
      else:
        self.user_name = str[start:end]
      _x = self
      start = end
      end += 8
      (_x.major_version, _x.minor_version,) = _struct_2i.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.yaml_data = str[start:end].decode('utf-8')
      else:
        self.yaml_data = str[start:end]
      self.save_time.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_2I = struct.Struct("<2I")
_struct_2i = struct.Struct("<2i")
